function [X,Y,R,T,MAT,XW1,YW1,XW2,YW2,MATW,MATLIST,MATWLIST,NumLoop,NumDisp,Gx,Gy,ADamp,DeltTScale,StrFile,XDisp,YDisp,M_ID,M_TYPE,BDEM_V0,BDEM_V,BDEM_F,BSDEM_F,WRT,VXW,VYW]=Ex_I_004
%--------------------------------------------------------------------------
% All copyrights reserved @ 2014-2050 Dr. Gaofeng Zhao
% TIANJIN UNIVERSITY (China)
% Email: dicetju@qq.com 
%--------------------------------------------------------------------------
% Example 04 (Chapter 3,Section3.4.2 BEAM)
%--------------------------------------------------------------------------
%-------------------------Display and Output Control-----------------------
global bFigOut; % 1/0: Save/(Not save) image files during calculation 
global bBondPlot;% 1/0: Plot/(Not plot) bond during calculation
global bDispNum;% 1/0: Plot/(Not plot) particle number
global bDispDisc;%1/0: Plot/(Not plot) particle model during calculation
global bOpenGL; % 0--default render, 1--OpenGL render
global bParticleModel;%1/0: Plot/(Not plot) particle model
%--------------------------------------------------------------------------
global dKs_Kn;
global IDListB;
global YP0;
global NDBEML;
global dBEAMF;
global dWRTValue;

dKs_Kn=0.1;
dWRTValue=0.1;

bFigOut=1;
bBondPlot=0;
bDispNum=0;
bDispDisc=1;
bOPenGL=1;
bParticleModel=1;

global LH;
global LV;
dBEAMF=-1000;
CN=10;
[X,Y,R,T,MAT]=Generate_Hex_Particle(10,10,10,5,41);

YP0=Y;
close;
XW1=[];
YW1=[];
XW2=[];
YW2=[];
MATW=[];
VXW=[];
VYW=[];

WRT=0.8;

MATLIST=[1e3 1e8 dKs_Kn*1.0e8 5e13 5e13 80 0 0];
% Density, Kn,Ks,Ft,C,Friction Angle
MATWLIST=[0 0 0];
%Ft,C,Friction Angle

% Num of Loops for the simulation
NumLoop=16400;
NumDisp=3200;
% Gravity
Gx=0.0;
Gy=0.0;
ADamp=dWRTValue;
DeltTScale=0.1;
PlotPW(X,Y,T,R,MAT,XW1,YW1,XW2,YW2);
box on;
h = gcf;
StrFile='EX_II004';
print(h,'-dbmp',strcat(StrFile,'Geo.bmp'));
XDisp=[min(X)-20,max(X)+20];
YDisp=[min(Y)-20,max(Y)+20];

xm=mean(X);
ym=mean(Y);

ID1=GetParticleID(X,Y,20*4,0);
ID2=GetParticleID(X,Y,20*(41-3),0);
ID3=GetParticleID(X,Y,21*20,5*20);
LH=X(ID2)-X(ID1);


ID4=GetParticleID(X,Y,X(ID1)+LH*0.125*1,0);
ID5=GetParticleID(X,Y,X(ID1)+LH*0.125*2,0);
ID6=GetParticleID(X,Y,X(ID1)+LH*0.125*3,0);
ID7=GetParticleID(X,Y,X(ID1)+LH*0.125*4,0);
ID8=GetParticleID(X,Y,X(ID1)+LH*0.125*5,0);
ID9=GetParticleID(X,Y,X(ID1)+LH*0.125*6,0);
ID10=GetParticleID(X,Y,X(ID1)+LH*0.125*7,0);

LV=Y(ID3)-Y(ID1)+50;%height of the beam

IDListB=[ID1,ID4,ID5,ID6,ID7,ID8,ID9,ID10,ID2];


NDBEML=[X(ID1),X(ID4),X(ID5),X(ID6),X(ID7),X(ID8),X(ID9),X(ID10),X(ID2)];
NDBEML=NDBEML-X(ID1);
NDBEML=NDBEML./LH;

M_ID=[ID1,ID2 ID3];
M_TYPE=[4 4 4];
Clr=hsv;
if bParticleModel==1
    for i=1:length(M_ID)
        PlotParticle2D(X(M_ID(i)),Y(M_ID(i)),R(M_ID(i)),T(M_ID(i)),10,[1.0 0.0 0.0]);
        text(X(M_ID(i)),Y(M_ID(i)),int2str(M_ID(i)));
    end
end
BDEM_V0=[];
BDEM_V=[ID1 1 0;ID1 2 0;ID2 2 0];
BDEM_F=[ID3 2 dBEAMF];
BSDEM_F=[];