function [X,Y,R,T,MAT,XW1,YW1,XW2,YW2,MATW,MATLIST,MATWLIST,NumLoop,NumDisp,Gx,Gy,ADamp,DeltTScale,StrFile,XDisp,YDisp,M_ID,M_TYPE,BDEM_V0,BDEM_V,BDEM_F,BSDEM_F,WRT,VXW,VYW]=Ex_I_008
%--------------------------------------------------------------------------
% All copyrights reserved @ 2014-2050 Dr. Gaofeng Zhao
% TIANJIN UNIVERSITY (China)
% Email: dicetju@qq.com 
%--------------------------------------------------------------------------
% Example 08 (Chapter 5: 5.2.2 Rock Cut)
%--------------------------------------------------------------------------
%-------------------------Display and Output Control-----------------------
global bFigOut; % 1/0: Save/(Not save) image files during calculation 
global bBondPlot;% 1/0: Plot/(Not plot) bond during calculation
global bDispNum;% 1/0: Plot/(Not plot) particle number
global bDispDisc;%1/0: Plot/(Not plot) particle model during calculation
global bOpenGL; % 0--default render, 1--OpenGL render
global bParticleModel;%1/0: Plot/(Not plot) particle model
%--------------------------------------------------------------------------
global dKs_Kn;
global dCWRT;
global dCFt;
global dFAngle;
global CNC;
global dKnn;
global iPostItem;
iPostItem=0;
bFigOut=1;
bBondPlot=0;
bDispNum=0;
bDispDisc=1;
bOPenGL=1;
bParticleModel=1;

global LH;
global LV;
global dAngle;
global dDepth;
global dCutVel;
dAngle=30;
dDepth=100;
dCutVel=5;

CNC=20;
dKs_Kn=0.3;
dCWRT=0.1;
dCFt=5.0;
dFAngle=30.0;

dKnn=1e8;
CN=CNC;
[X,Y,R,T,MAT]=ReadFromFile('ModelCut.PNO');
close;
XW1=[0 480 0 0];
YW1=[0 0 0 240-dDepth];
XW2=[480 480 0 0-(10+dDepth)/tan(dAngle/180*pi)];
YW2=[0 250 100 250];
MATW=[1 1 1 1];
VXW=[0 0 0 dCutVel];
VYW=[0 0 0 0];


WRT=dCWRT;
MATLIST=[1e3 dKnn dKs_Kn*dKnn 2e6*20 dCFt*2e6*20 dFAngle 0 0];
% Density, Kn,Ks,Ft,C,Friction Angle
MATWLIST=[1e10 1e10 60];
%Ft,C,Friction Angle
% Num of Loops for the simulation
%36000
NumLoop=36000*(CNC/20);
NumDisp=2000;
% Gravity
Gx=0.0;
Gy=0.0;
ADamp=0.8;
DeltTScale=0.1;
PlotPW(X,Y,T,R,MAT,XW1,YW1,XW2,YW2);
box on;
h = gcf;
StrFile='EX_IV002';
print(h,'-dbmp',strcat(StrFile,'Geo.bmp'));
XDisp=[min(X)-50,max(X)+50];
YDisp=[min(Y)-50,max(Y)+50];

xm=mean(X);
ym=mean(Y);

ID1=GetParticleID(X,Y,xm-CN*0.25*20,ym);
ID2=GetParticleID(X,Y,xm+CN*0.25*20,ym);
ID3=GetParticleID(X,Y,xm,ym-CN*0.25*20);
ID4=GetParticleID(X,Y,xm,ym+CN*0.25*20);

M_ID=[ID1 ID2 ID3 ID4 4 4];
M_TYPE=[4 4 5 5 12 11];
Clr=hsv;
LH=X(ID2)-X(ID1);
LV=Y(ID4)-Y(ID3);
if bParticleModel==1
    for i=1:length(M_ID)
        if M_TYPE(i)<11
           PlotParticle2D(X(M_ID(i)),Y(M_ID(i)),R(M_ID(i)),T(M_ID(i)),10,[1.0 0.0 0.0]);
           text(X(M_ID(i)),Y(M_ID(i)),int2str(M_ID(i)));
        end
    end
end
BDEM_V0=[];
BDEM_V=[];
BDEM_F=[];
BSDEM_F=[];