function Ex_P_004(HData,sFile)
%--------------------------------------------------------------------------
% All copyrights reserved @ 2014-2050 Dr. Gaofeng Zhao
% TIANJIN UNIVERSITY (China)
% Email: dicetju@qq.com 
%--------------------------------------------------------------------------
% Example 4 (Chapter 3,Section3.4.2 BEAM)
%--------------------------------------------------------------------------
global LH;
global LV;
global IDListB;
global YP0;
global Y;
global NDBEML;
global dBEAMF;
global UyBeamMax;
global EBEAM;
global UyBeam;

clf;
n=length(IDListB);
UyBeam=zeros(1,n);
for i=1:n
    UyBeam(i)=Y(IDListB(i))-YP0(IDListB(i));
end

UyBeamMax=min(UyBeam)

UyBeam=-UyBeam./UyBeamMax;

IBEAM=LV*LV*LV/12.0;

EBEAM=dBEAMF*LH*LH*LH/(48*UyBeamMax*IBEAM)

plot(NDBEML,UyBeam,'ko','linewidth',2);
hold on;

%Analytical Solution

UxA=linspace(0,1,50);
UyA=UxA;
for i=1:50
    if(UxA(i)<0.5)
        UyA(i)=UxA(i)*(4*UxA(i)*UxA(i)-3);
    else
        UyA(i)=(1-UxA(i))*(4*(1-UxA(i))*(1-UxA(i))-3);
    end
end
plot(UxA,UyA,'r','linewidth',2);
xlabel('x/L');
ylabel('u/|u_m_a_x|');
legend('DEM','Analytical solution');
h= gcf;
strOutFile=sprintf('%sFinalRstExII004.bmp',sFile);
print(h,'-dbmp',strOutFile);